#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#define SHUTDOWN_LIMIT 10

int get_number_of_users();
void shutdown();

int main()
{
    int no_one_logged_in_since=0;
    int number_of_users;

    while(1)
    {
	number_of_users=get_number_of_users();
	if(number_of_users>0)
	    no_one_logged_in_since=0;
	else
	    no_one_logged_in_since++;

	if(no_one_logged_in_since==SHUTDOWN_LIMIT)
	{
	    no_one_logged_in_since=0;
	    shutdown();
	}
	sleep(60);
    }

    exit(EXIT_SUCCESS);
    return 0;
}


int get_number_of_users()
{
    FILE *temp_file;
    int number_of_users;
    system("w -hs | wc -l > /tmp/user_count.txt");
    temp_file=fopen("/tmp/user_count.txt", "r");
    fscanf(temp_file,"%d",&number_of_users);
    fclose(temp_file);
    unlink("/tmp/user_count.txt");
    printf("Number of users %d\n", number_of_users);

    return number_of_users;
}

void shutdown()
{
    system("shutdown -h now");
}
